<template>
  <ObModal
    ref="modal"
    title="Закольцовки для заказа"
    :title-second="titleSecond"
    :is-show-controls="true"
    :is-read-only="true"
    size="suborder-approaching"
    class="approaching-modal"
    data-qa="approachingModal"
  >
    <div class="order-approaching">
        <div class="order-approaching__top">
          <Route
            :route-data="routeData"
          />
        </div>
        <div class="order-approaching__columns">
          <div class="column-item">
            <div class="column-item__header">
              <div>Можно закольцевать “туда” из:</div>
              <div>
                <i class="icon city-sm" />
                <span>{{ order.startAddress }}</span>
              </div>
            </div>
            <div class="column-item__filters">
              <span>Поиск:</span>
              <ObRadio
                v-model="exactRoute"
                :value-input="false"
                label="только по “откуда”"
              />
              <ObRadio
                v-model="exactRoute"
                :value-input="true"
                label="по “откуда” и “куда”"
              />
            </div>
            <ObTable
              ref="approachingTable"
              :columns="approachingColumns"
              :remote-opt="getApproachingSuborders"
              :remote-trigger="dataTrigger"
            >
              <template slot="status" slot-scope="{ data }">
                <img v-if="!data.item.accuracy" src="@/components/Order/modal/icons/status-0.svg" alt="">
                <img v-else src="@/components/Order/modal/icons/status-1.svg" alt="">
              </template>
              <template slot="gosNumber" slot-scope="{ data }">
                <template v-if="data.item.tractorNumber">
                  <div class="gos-number">
                    <span class="block">{{ data.item.tractorGosNumber.grzNum }}</span>
                    <span class="block"> {{data.item.tractorGosNumber.grzReg }}</span>
                  </div>
                </template>
                <template v-if="data.item.trailerNumber">
                  <div class="gos-number">
                    <span class="block">{{ data.item.trailerGosNumber.grzNum }}</span>
                    <span class="block">{{ data.item.trailerGosNumber.grzReg }}</span>
                  </div>
                </template>
              </template>
              <template slot="executorInfo" slot-scope="{ data }">
                <div class="executor-info">
                  <div class="executor-info__title">
                    {{ data.item.carrierTitle }}
                  </div>
                  <div class="executor-info__driver">
                    {{ data.item.driverFio }}
                  </div>
                  <div class="executor-info__phone">
                    {{ data.item.phone }}
                  </div>
                </div>
              </template>
              <template slot="departure" slot-scope="{ data }">
                <template v-if="isActualOrder(data.item)">
                  <div class="departure-block">
                    <div class="field-datetime">
                      {{ data.item.departureDt | date('DD.MM.YY') }}
                      <span class="field-datetime__time">
                        {{ data.item.departureDt | date('HH.mm') }}
                      </span>
                    </div>
                    <div class="departure-block__info">
                      <ObCountdown :duration="data.item.timelag * 60" /> / <span>{{ data.item.distance }} км</span>
                    </div>
                  </div>
                </template>
                <template v-else>
                  <div class="field-datetime">
                    <span class="field-datetime__time">Ранее ездил</span>
                  </div>
                </template>
              </template>
              <template slot="offerStatus" slot-scope="{ data }">
                <div
                  class="status-block"
                  :class="getColorClassByStatus(data.item)"
                >
                  <template v-if="data.item.offerStatus">
                    <div class="status-block__price">
                      {{ data.item.offerPrice / 100 | currency }} ₽
                    </div>
                    <div class="status-block__label">
                      {{ getLabelByStatus(data.item) }}
                    </div>
                    <button
                      v-if="isShowRepeatSendButton(data.item)"
                      class="status-block__go-offer"
                      @click="goOffer(data.item)"
                    >
                      Повторить
                    </button>
                  </template>
                  <template v-else>
                    <ObButton
                      label="Запрос"
                      type="primary-success"
                      @click="goOffer(data.item)"
                    />
                  </template>
                </div>
              </template>
            </ObTable>
          </div>
          <div class="column-item">
            <div class="column-item__header">
              <div>Можно закольцевать “обратно” из:</div>
              <div>
                <i class="icon city-sm" />
                <span>{{ order.endAddress }}</span>
              </div>
            </div>
            <ObTable
              ref="loopingTable"
              :columns="loopingColumns"
              :remote-opt="getLoopingSuborders"
              :remote-trigger="dataTrigger"
            >
              <template slot="radio" slot-scope="{ data }">
                <ObRadio
                  v-model="selectedLoopingSuborder"
                  :value-input="data.item.uuid || false"
                />
              </template>
              <template slot="route" slot-scope="{ data }">
                <div
                  v-if="data.item.fromAddress"
                  class="route-block"
                >
                  <div class="route-block__left">
                    <div class="title">
                      <i class="icon city-sm" />
                      <span>{{ data.item.fromAddress.locationTitle }}</span>
                    </div>
                    <div class="address">{{ data.item.fromAddress.addressTitle }}</div>
                  </div>
                  <div class="route-block__sep"></div>
                  <div class="route-block__right">
                    <div class="title">
                      <span>{{ data.item.toAddress.locationTitle }}</span>
                      <i class="icon city-sm" />
                    </div>
                    <div class="address">{{ data.item.toAddress.addressTitle }}</div>
                  </div>
                </div>
                <div v-else>
                  Без кругорейса
                </div>
              </template>
              <template slot="datetime" slot-scope="{ data }">
                <div
                  v-if="data.item.uuid"
                  class="field-datetime"
                >
                  {{ data.item.pvpDt | date('DD.MM.YY') }}
                  <div class="field-datetime__time">
                    {{ data.item.pvpDt | date('HH.mm') }}
                  </div>
                </div>
              </template>
              <template slot="client" slot-scope="{ data }">
                <div
                  v-if="data.item.uuid"
                  class="client-block"
                >
                  <div class="client-block__title">
                    <i class="icon role-client" />
                    <span>{{ data.item.clientTitle  }}</span>
                  </div>
                  <div class="client-block__order-number">
                    {{ data.item.orderNumber }}
                  </div>
                </div>
              </template>
            </ObTable>
          </div>
        </div>
    </div>
    <ApproachingOfferModal
      ref="offerModal"
      :data-source="currentOfferData"
      @submitted="onSubmittedOfferForm"
    />
  </ObModal>
</template>

<script>
import api from '@/api'
import ObModal from 'common-components/src/obComponents/obModal'
import ObTable from 'common-components/src/obComponents/obTable'
import ObRadio from 'common-components/src/obComponents/obRadio'
import ObCountdown from 'common-components/src/obComponents/obCountdown'
import ObButton from 'common-components/src/obComponents/obButton'
import Route from '../orderItem/execution/RouteSimple'
import ApproachingOfferModal from "@/components/Order/modal/ApproachingOfferModal"
import cloneDeep from "clone-deep";

export default {
  name: 'ApproachingModal',
  components: {
    ObModal,
    ObTable,
    ObRadio,
    ObCountdown,
    Route,
    ObButton,
    ApproachingOfferModal
  },
  props: {
    order: {
      type: Object,
      default: () => {}
    }
  },
  data () {
    return {
      isLoading: false,
      exactRoute: false,
      selectedLoopingSuborder: false,
      currentOfferData: {}
    }
  },
  computed: {
    dataTrigger () {
      return this.exactRoute.toString()
    },
    titleSecond () {
      return `Рейс:  ${this.order.startAddress} — ${this.order.endAddress}`
    },
    routeData () {
      const sortShipments = cloneDeep(this.order?.shipmentPoints || []).sort((a, b) => a.ordinal - b.ordinal)
      const startPoint = this.order?.shipmentPoints?.find(item => item.ordinal === 1) || {}
      const endPoint = sortShipments[sortShipments.length - 1] || {}
      const serviceTypeUuid = this.order?.service?.serviceTypeUuid

      return {
        startLocation: startPoint.title,
        startAddress: startPoint.addressTitle,
        plannedSlotStartAt: startPoint.plannedSlotStartAt,
        endLocation: endPoint.title,
        endAddress: endPoint.addressTitle,
        plannedSlotEndAt: endPoint.plannedSlotStartAt,
        resourceSubtypeTitle: this.order?.service?.resourceSubtypeTitle,
        resourcePatternParameter: this.order?.service?.resourcePatternParameter,
        serviceTypeUuid,
        tariffLimit: this.order.tariffLimit
      }
    },
    approachingColumns () {
      return [
        {
          title: ' ',
          key: 'status',
          slotName: 'status',
          sortDisable: true,
          exactWidth: '20px'
        },
        {
          title: 'тягач/фургон, прицеп',
          key: 'gosNumber',
          slotName: 'gosNumber',
          exactWidth: '90px',
          sortDisable: true,
        },
        {
          title: 'Перевозчик, Водитель, контакты',
          key: 'executorInfo',
          slotName: 'executorInfo',
          exactWidth: '200px',
          sortDisable: true,
        },
        {
          title: 'окончание разгрузки / запас по времени и км',
          key: 'departure',
          slotName: 'departure',
          isAlignRight: true,
          exactWidth: '130px',
          sortDisable: true,
        },
        {
          title: '',
          key: 'offerStatus',
          slotName: 'offerStatus',
          isAlignRight: true,
          exactWidth: '140px',
          sortDisable: true,
        }
      ]
    },
    loopingColumns () {
      return [
        {
          title: ' ',
          key: 'radio',
          slotName: 'radio',
          sortDisable: true,
          width: 30
        },
        {
          title: 'Маршрут',
          key: 'route',
          slotName: 'route',
          sortDisable: true,
          exactWidth: '210px',
        },
        {
          title: 'Дата и время ПВП',
          key: 'datetime',
          slotName: 'datetime',
          sortDisable: true,
          exactWidth: '60px',
        },
        {
          title: 'Клиент и номер заказа',
          key: 'client',
          slotName: 'client',
          sortDisable: true,
          width: 130
        },
      ]
    },
  },
  methods: {
    open () {
      this.initLoadData()
      this.$refs.modal.open()
    },
    close () {
      this.$refs.modal.close()
    },
    initLoadData () {
      this.selectedLoopingSuborder = false
      this.$refs.approachingTable?.loadData({ init: true })
      this.$refs.loopingTable?.loadData({ init: true })
    },
    async getApproachingSuborders ({ page, size }) {
      try {
        return await api.orderProcess.getApproachingSuborders({
          suborderUuid: this.order.uuid,
          exactRoute: this.exactRoute,
          page,
          size,
        })
      } catch (err) {
        console.error(err)
      }
    },
    async getLoopingSuborders ({ page, size }) {
      try {
        let res = await api.orderProcess.getLoopingSuborders({
          suborderUuid: this.order.uuid,
          exactRoute: this.exactRoute,
          page,
          size,
        })

        res.content = [{ uuid: null }, ...res.content]

        return res
      } catch (err) {
        console.error(err)
      }
    },
    isActualOrder (data) {
      return data.accuracy > 0
    },
    async goOffer (data) {
      const toSuborderUuid = data.uuid
      const carrierUuid = data.carrierUuid
      const targetSuborderUuid = this.order.uuid
      const fromSuborderUuid = this.selectedLoopingSuborder || null
      const requestParams = {
        toSuborderUuid,
        carrierUuid,
        targetSuborderUuid,
        fromSuborderUuid
      }
      const resData = await api.orderProcess.getInfoForOffer({
        ...requestParams
      })
      this.currentOfferData = {
        ...requestParams,
        ...resData
      }
      this.$refs.offerModal.open()
    },
    getColorClassByStatus (data) {
      const statusMap = {
        NEW: '-caribbean-green',
        EXPIRED: '-light-raspberry-red',
        REJECTED: '-light-raspberry-red',
      }

      return statusMap[data.offerStatus]
    },
    getLabelByStatus (data) {
      const statusMap = {
        NEW: 'Отправлено',
        EXPIRED: 'Превышен лимит ожидания',
        REJECTED: 'Отклонено',
      }

      return statusMap[data.offerStatus]
    },
    isShowRepeatSendButton (data) {
      return [ 'EXPIRED', 'REJECTED' ].includes(data.offerStatus)
    },
    onSubmittedOfferForm () {
      this.$refs.approachingTable?.loadData()
    }
  }
}
</script>

<style lang="scss" scoped>
  @import "~common-components/src/static/css/mixins";

  .field-datetime {
    @include font-mixin(14px, 20px, 400);

    .field-datetime__time {
      color: $color-grey-span;
    }
  }

  .order-approaching {
    &__top {
      margin-bottom: 25px;
    }
    &__columns {
      display: flex;
      &::v-deep {
        .ob-table-inner {
          min-height: 300px;
          max-height: 450px;
        }
        th {
          vertical-align: middle;
        }
        .td-container {
          width: 100%;
          padding: 10px!important;
        }
        .table-footer {
          .page-input {
            display: none;
            margin-left: 0;
          }
        }
        th:first-child {
          .td-container {
            padding-left: 15px!important;
          }
        }
        td:first-child {
          .td-container {
            padding-left: 15px!important;
          }
          .ob-radio-container {
            transform: translate(10px, -3px);
          }
        }
        th:last-child, td:last-child {
          .td-container {
            padding-right: 15px!important;
          }
        }
        .none-data-slot {
          border-top: 1px $lavender solid;
        }
      }
      .column-item + .column-item {
        margin-left: 30px;
      }
      .column-item {
        width: 50%;
        display: flex;
        flex-direction: column;
        background: #FFFFFF;
        box-shadow: 0px 0px 2px rgba(0, 75, 200, 0.15), 0px 0px 12px rgba(0, 75, 200, 0.04), 0px 4px 10px rgba(0, 75, 200, 0.06);
        border-radius: 10px;
        &__header {
          display: flex;
          align-items: center;
          justify-content: space-between;
          padding: 20px;
          @include font-mixin(16px, 20px, 900, $color-text-base, 1.6px);
          & > div {
            display: flex;
            align-items: center;
            .icon {
              margin-right: 9px;
              font-size: 14px;
              color: $color-blue-navy-blue;
            }
          }
        }
        &__filters {
          display: flex;
          align-items: center;
          padding: 20px 15px;
          border-top: 1px $lavender solid;
          @include font-mixin(14px, 20px, 400);
          &::v-deep {
            .ob-radio-container {
              margin-left: 15px;
            }
          }
        }
      }
      .gos-number:not(:first-of-type) {
        margin-top: 6px;
      }
      .departure-block {
        text-align: right;
        &__info {
          margin-top: -1px;
          @include font-mixin(12px, 18px, 400, $gray-slate);
        }
      }
      .executor-info {
        max-width: 240px;
        &__title {
          @include font-mixin(14px, 18px, 400);
        }
        &__title, &__driver, &__phone {
          max-width: 100%;
          white-space: nowrap;
          overflow: hidden;
          text-overflow: ellipsis;
        }
        &__phone, &__driver {
          @include font-mixin(12px, 18px, 400, $gray-slate);
        }
      }
      .route-block {
        display: flex;
        &__left, &__right {
          max-width: 135px;
        }
        &__left {
          .title {
            .icon {
              margin-right: 9px;
            }
          }
        }
        &__right {
          .title {
            .icon {
              margin-left: 9px;
            }
          }
        }
        .title {
          display: flex;
          align-items: center;
          .icon {
            font-size: 14px;
            color: $color-blue-navy-blue;
          }
          span {
            max-width: 100%;
            white-space: nowrap;
            overflow: hidden;
            text-overflow: ellipsis;
          }
        }
        .address {
          max-width: 100%;
          white-space: nowrap;
          overflow: hidden;
          text-overflow: ellipsis;
          margin-top: 4px;
          @include font-mixin(10px, 14px, 400, $gray-slate);
        }
        &__sep {
          min-width: 14px;
          height: 11px;
          margin: 0 20px;
          border-bottom: 2px $blue-300 dotted;
        }
      }
      .client-block {
        max-width: 160px;
        &__title {
          display: flex;
          align-items: center;
          .icon {
            margin-right: 8px;
            font-size: 16px;
            color: $color-blue-navy-blue;
          }
          span {
            max-width: 100%;
            white-space: nowrap;
            overflow: hidden;
            text-overflow: ellipsis;
            @include font-mixin(14px, 18px, 400);
          }
        }
        &__order-number {
          margin-top: 4px;
          @include font-mixin(10px, 14px, 400, $color-blue-navy-blue, 0.4px);
        }
      }
      .status-block {
        min-height: 65px;
        display: flex;
        flex-direction: column;
        justify-content: center;
        align-items: flex-end;
        text-align: right;
        &__price {
          padding-right: 3px;
          @include font-mixin(14px, 18px, 400);
        }
        &__label {
          margin-top: 2px;
          padding-right: 3px;
          @include font-mixin(10px, 12px, 400);
        }
        &__go-offer {
          margin-top: 3px;
          background-color: transparent;
          border: none;
          outline: none;
          cursor: pointer;
          @include font-mixin(10px, 12px, 400, $color-blue-navy-blue);
          &:hover {
            opacity: 0.8;
          }
        }
      }
    }
  }
</style>

<style lang="scss">
.modal-suborder-approaching {
  width: 1500px!important;
  max-width: calc(100vw - 30);
}
</style>
